package sun.management;

import com.sun.management.OperatingSystemMXBean;

class OperatingSystemImpl extends BaseOperatingSystemImpl implements OperatingSystemMXBean
{
    private static Object psapiLock;
    
    OperatingSystemImpl(VMManagement vmManagement) {
        super(vmManagement);
    }
    
    @Override
    public long getCommittedVirtualMemorySize() {
        synchronized (OperatingSystemImpl.psapiLock) {
            return this.getCommittedVirtualMemorySize0();
        }
    }
    
    private native long getCommittedVirtualMemorySize0();
    
    @Override
    public native long getTotalSwapSpaceSize();
    
    @Override
    public native long getFreeSwapSpaceSize();
    
    @Override
    public native long getProcessCpuTime();
    
    @Override
    public native long getFreePhysicalMemorySize();
    
    @Override
    public native long getTotalPhysicalMemorySize();
    
    @Override
    public native double getSystemCpuLoad();
    
    @Override
    public native double getProcessCpuLoad();
    
    private static native void initialize();
    
    static {
        OperatingSystemImpl.psapiLock = new Object();
        initialize();
    }
}
